;
; ERRORS.S
;
; Bandit error messages
;

IDS     3000, 3399
SEG ERRORS

; Standard messages

AskOffline,                     "Desea trabajar sin conexin a la red?"
AskCreateSched,         "Desea crear un archivo de agenda nuevo?"
AskCreateFind,                  "Desea buscar el archivo de agenda?"
OldFileVersion,         "Su archivo de agenda est en un formato antiguo. Est bien eliminar el archivo y hacer uno nuevo para usted?"
NewFileVersion,         "Su archivo de agenda ha sido actualizado a la versin ms reciente. Instale la ltima versin en su computadora."
CantUpdateWinIni,       "Parte de la informacin de configuracin de Schedule+ no ha podido ser guardada."
; Note: StdMemErr should be followed by CloseWindows
StdMemErr,                              "No hay suficiente memoria disponible para llevar a cabo esta accin."

; Execution-Startup messages

; Note: the name OfflineNotUpdated is opposite of real meaning!
OfflineNotUpdated,      "Los ltimos cambios que hizo en su archivo de agenda, mientras trabajaba con conexin a la red, quizs no aparezcan en su copia del archivo de agenda sin conexin a la red. Estos cambios han sido guardados en la copia con conexin a la red y sern reflejados en la copia sin conexin a la red la prxima vez que trabaje con conexin a la red."
ExportOldDataFirst,     "Si no ha hecho una copia de seguridad de su agenda usando el comando 'Exportar', elija 'Cancelar' y haga una copia de seguridad de su archivo de agenda usando una versin anterior de Schedule+. Si no necesita hacer una copia de respaldo de su agenda, elija 'Aceptar' para continuar."
AccessErr,              "Otra aplicacin est usando este archivo."
UploadFailed,           "No fue posible cargar en el servidor su archivo de agenda local." 
Uploading,                      "Cargando el archivo de agenda..."
VerifyUpload,           "Schedule+ necesita verificar su contrasea sin conexin a la red para cargar su archivo sin conexin a la red."
VerifyPostUpload,       "Schedule+ necesita verificar su contrasea con conexin a la red para terminar de cargar su archivo sin conexin a la red."
FindUpload,                     "Esta es la primera vez que utiliza Schedule+ en su computadora?"
NotYourFile,            "Este no es un archivo de agenda local vlido. Est bien si se elimina? "


; SignIn messages

; Note: SigninBadPassword should be followed by PleaseTryAgain
SigninBadPassword,      "Esta contrasea no es correcta."
; Note: the word "password" within single quotes below should always be
;       the same as the value in SigninDfltPassword in the file "intl.s"
SigninFileCreated,      "Se cre para usted un nuevo archivo. Su contrasea ha sido establecida a 'password'. Puede cambiarla usando el comando 'Cambiar contrasea'."
SigninFileCopied,               "Se cre para usted un nuevo archivo local en su directorio de Schedule+."

; Online signin messages

SigninNoServer,         "No es posible obtener acceso a su servidor."
SigninServerNotBandit,  "Schedule+ no se instal en su servidor de correo. Comunquese con su administrador del sistema."
; Note: SigninBadMailBoxName should be followed by PleaseTryAgain
SigninBadMailboxName,   "No hay ningn usuario en este servidor de correo con este nombre de buzn. Asegrese de que el nombre del buzn est escrito correctamente y que el Administrador del sistema haya creado una cuenta para su servidor de correo."


SigninNoSchedule,       "No hay ningn archivo de agenda para usted en este servidor de correo."
; Note: SigninCantUpdateLocal is actually the trailer for SigninNoLclSchedAccess
;       in the case when we can't update the local file.
SigninCantUpdateLocal,  "Si ha hecho cambios sin conexin a la red, quizs no aparezcan en su agenda. Quizs desee hacer una nueva copia local."
SigninNoPasswdCheck,    "Hay un problema con el sistema de correo el cual impide la conexin de Schedule+ con su servidor de correo."
; Note: SigninNoCreateLocal should be followed by PleaseTryAgain
SigninNoCreateLocal,    "No fue posible crear el archivo de agenda local."

; Offline signin messages

SigninNoLclSchedFile,   "No tiene un archivo de agenda en esta computadora."
SigninDiffUser,                 "El nombre de registro que introdujo no es el mismo nombre del usuario que tiene un archivo de agenda almacenado en esta computadora. Desea crear un nuevo archivo de agenda para reemplazar el archivo del usuario?"
; Note: SigninNoLclSchedAccess - 'schdpl32.ini' should be same as idsWinIniFilename in \bandit\src\nonintl.s
SigninNoLclSchedAccess, "No se ha podido acceder a la copia local de su archivo de agenda con la configuracin actual."
SigninNoLclSchedDrive,	"Inserte el disco desprotegido contra escritura que contiene su archivo de agenda dentro de la unidad"

; SignInAs messages

;;;SigninAsLoseMeetingReq,      "Changing identity now will cause you to lose the information you have entered into unsent messages."

; Offline to online merge messages

MergingChanges,                 "Combinando cambios hechos sin conexin a la red..."
MergeError,                     "No fue posible combinar los cambios hechos sin conexin a la red. Algunos de los cambios hechos sin conexin a la red pudieron perderse."
MergeOfflineOldVer,             "No fue posible combinar los cambios hechos sin conexin a la red, debido a que su archivo sin conexin a la red fue creado con una versin anterior de Schedule+."
MergeOfflineNewVer,             "No es posible combinar los cambios hechos sin conexin a la red, debido a que su archivo sin conexin a la red fue creado con una versin ms reciente de Schedule+. Para combinar los cambios necesitar instalar una versin ms reciente de Schedule+ en su computadora."
AskContinue,                    "Desea trabajar con conexin a la red de todas maneras?"
FemaCreateAppt,                 "crear elemento"
FemaDeleteAppt,                 "eliminar elemento"
FemaSetApptFields,              "modificar elemento"
FemaCreateRecur,                "crear elemento peridico"
FemaDeleteRecur,                "eliminar elemento peridico"
FemaSetRecurFields,             "modificar elemento peridico"

; (Dis)Connect To/From Server messages

ConnectBadMailboxName,  "No hay ninguna cuenta de correo para usted en este servidor de correo."
DisconLoseMeetingReq,   "Tiene mensajes sin enviar. Si se desconecta de su servidor de correo ahora perder esos mensajes."

; Create/move local file

NoDiskSpaceLocal,               "No hay suficiente espacio en el disco para crear un archivo de agenda local."

; Alarms messages

; BUG: CantTurnOnAlarms can be commented out
CantTurnOnAlarms,               "No fue posible activar los avisos."
; exe name inside AlarmNoExe should be the same as \bandit\src\nonintl.s AlarmApp
AlarmNoExe,                     "No fue posible encontrar el archivo MSRMND32.EXE. No ser avisado de los eventos de Schedule+."
AlarmNoMemExe,                  "No hay suficiente memoria para avisarle de los eventos de Schedule+."

; Change password messages

ChgPwdOffline,                  "La contrasea nueva funcionar nicamente cuando est trabajando sin conexin a la red. La prxima vez que trabaje con conexin a la red, su contrasea volver a ser su contrasea de correo. Desea cambiar su contrasea de todos modos?"
ChgPwdNewPwd,                   "Escriba su contrasea nueva."
ChgPwdSame,                             "Su contrasea nueva no puede ser igual que su contrasea anterior."
ChgPwdNewPwdAgain,              "Para verificar, escriba una vez ms su contrasea nueva."
; Note: ChgPwdNewNoMatch should be followed by PleaseTryAgain
ChgPwdNewNoMatch,               "Las dos contraseas que escribi no coinciden."
ChgPwdMailErr,                  "No fue posible cambiar su contrasea."

PasswdDiff,                     "Sus contraseas no coinciden. Escriba su contrasea del archivo de agenda."
GiveMailPass,           "Schedule+ necesita verificar su contrasea de correo para actualizar su archivo de agenda."

; Access permissions/privileges dialog messages

AclSaveFileError,               "Ocurri un error al guardar los cambios en sus privilegios de acceso de la agenda. Quizs algunos cambios no fueron guardados."
OneSecyOnly,                    "Slo una persona por vez puede ser su asistente. "
DistOtherFileErr,               "Ocurri un error al tratar de guardar sus preferencias."
BadWorkDay,                             "Las horas especificadas de Inicio/Fin del da no son vlidas."

; Appointment book/scheduler error messages

AccessFileErr,          "No fue posible abrir un archivo de agenda. Quizs no tiene los privilegios de acceso necesarios, o el archivo no est disponible."
AccessFileErrMult,      "No fue posible abrir uno o ms de los archivos de agenda. Quizs no tiene los privilegios de acceso necesarios, o el archivo no est disponible."
RetryReadAppts,         "No fue posible leer el archivo de agenda."
CloseApptBook,          "No fue posible obtener acceso al archivo de agenda.\n%s's El Libro de citas estar cerrado."
GoOffline,                      "No fue posible obtener acceso a su archivo de agenda.\nDesea cambiarse a su archivo de agenda local y continuar trabajando sin conexin a la red?"
NoImportAcc,            "Usted no tiene el privilegio de acceso correcto para importar citas dentro de la agenda de esa persona."
FemaReadSBW,            "leer la informacin de la agenda"

; Appointments/alarms error messages

AlarmBadDelta,                  "El tiempo del aviso debe ser un nmero entre el 0 al 99."
; Note: AlarmFuture is actually the trailer for AlarmFutureNoOption when option is desired!
AlarmFuture,                    "Est bien?"
AlarmFutureNoOption,    "El aviso para este evento no ser establecido debido a que el tiempo para ste ya pas."
ApptStartBeforeEnd,             "El inicio de la cita debe estar antes del final de la cita."
ApptTooLong,                    "Las citas no pueden ser ms largas de 31 das."
ApptNoMemText,                  "No hay suficiente memoria para guardar el ltimo cambio que hizo."
ApptNoAccessDataFile,   "No fue posible obtener acceso al archivo de agenda. No se ha guardado el ltimo cambio que hizo."
CannotCreate,                   "%s no le ha otorgado permiso a usted para crear citas."
NoModifyAccess,                 "Usted no tiene los privilegios de acceso correctos para modificar esta cita."
NoDeleteAccess,                 "Usted no tiene los privilegios de acceso correctos para eliminar esta cita."
NoCopyAccess,                   "Usted no tiene los privilegios de acceso correctos para copiar esta cita."

; Meeting request/response error Messages

; Note: SendErr should be preceded by MailErr
SendErr,                                "No fue posible enviar este mensaje."
; Note: SendMemErr should be followed by CloseWindows
SendMemErr,                             "No hay suficiente memoria para enviar este mensaje."
ServerErr,                              "No fue posible obtener acceso a su servidor de correo."
MailErr,                                "Hay un problema con el sistema de correo."
; Note: ReadErr should be preceded by MailErr
ReadErr,                                "No es posible leer los mensajes."
DeleteErr,                              "No ha ledo todos estos mensajes. Desea eliminarlos de todos modos?"
AddConflictErr,                 "Esta reunin est en conflicto con citas existentes. Desea aadirla de todos modos?"
; Note: DeleteFailErr should be preceded by MailErr
DeleteFailErr,                  "No fue posible eliminar los mensajes."
ApptBooked,                             "La reunin se reserv con xito."
MinimizeSummary,                "\nLas ventanas de mensajes sern minimizadas."
; Note: NoDetails should be preceded by MailErr
NoDetails,                              "No fue posible leer los detalles del usuario."

; Find error messages

FindNoText,                             "No hay ninguna cita en esta agenda."
FindSchFileLocked,              "No fue posible leer el archivo de agenda debido a que otra persona lo est cambiando en estos momentos."
FindFileError,                  "No fue posible obtener acceso al archivo de agenda."
FindEOS,                                "Se lleg al final de la agenda."

; Print error messages

PrtPrintingDate,                "Imprimiendo %s..."
PrtNoneInstalled,               "Su computadora no ha sido configurada para usar cualquier impresora. Puede instalar impresoras desde el Panel de control de Windows NT."
PrtDiffPrinter,                 "La impresora que normalmente usa para imprimir su agenda,'%1s' no est disponible. Desea imprimir en la impresora del sistema '%2s'?"
PrtInvalidMargins,              "Estas configuraciones de mrgenes no son vlidas para este tamao de papel."
PrtNotEnoughPaper,              "No hay suficiente espacio en el papel para imprimir usando este formato. Use un tamao de papel ms grande o reduzca las configuraciones de mrgenes."
PrtNoAppointments,              "Ninguna cita sucede dentro del rango seleccionado."
ClippedMargins,                 "Al imprimir con estas configuraciones de mrgenes causar que la salida se trunque."
PrtNotOnline,                   "La impresora seleccionada no est lista."
PrtDorkErr,                             "Con estas configuraciones de mrgenes, alguna parte del texto puede desaparecer completamente o aparecer truncado."
PrinterProblem,                 "Hubo un problema con el controlador de impresin. Por favor, verifique sus conexiones y las configuraciones en el panel de control."

; Export/import error messages

ImportError,                    "Hubo un problema al importar el archivo. Quizs no se aadieron algunos elementos."
ImportEncrypt,                  "El archivo de importacin est protegido con una contrasea. Quite la contrasea del archivo e intntelo de nuevo."
ExportError,                    "Hubo un problema al exportar las citas."
ImportDate,                             "Un elemento en este archivo est reservado para una fecha fuera de las fechas apoyadas por Schedule+ (1920 - 2019). Este elemento no ser aadido."
NotePrivErr,                    "No puede importar notas de la agenda de otra persona. Solo se aadirn citas."
ConflictMsg,                    "Esta cita estar en conflicto con una cita existente en su agenda. Desea aadirla de todas maneras?\n\n"
CreateExport,                   "No fue posible crear el archivo de exportacin."
OpenImport,                             "No fue posible abrir el archivo de importacin."
Overwrite,                              "%s ya existe.\nDesea reemplazarlo?"
ImportDllError,                 "No fue posible cargar una DLL importadora."
WrongFormat,                    "El archivo que est tratando de importar no est en un formato de importacin vlido."
ImportDayLimit,                 "Una cita peridica en este archivo est planificada para durar ms de 31 das. Esta cita no ser aadida."
ImportErrorLine,                "Hubo un problema al importar el archivo (cerca de la lnea %n). Quizs no se aadieron algunos elementos."

; Exit messages

ExitLoseMeetingReq,             "Si sale de Schedule+ en estos momentos perder la informacin contenida en los mensajes sin enviar. Desea salir de todos modos?"

; Misc

; Note: HelpError should be followed by CloseWindows
HelpError,                              "No hay suficiente memoria para mostrar la Ayuda."
StartBeforeEnd,                 "La fecha del inicio debe ser anterior a la fecha del final."
NotSecretary,                   "Usted ya no es ms el asistente de %s."
NoFileSecretary,                "No es posible obtener acceso al archivo de %s."

;Recurring appt stuff
RecurOrNot,                             "Esta cita es una aparicin de una cita peridica. Desea modificarla en todas partes o  nicamente en este da?"
EmptyRecur,                             "No hay ningn da que coincide con este modelo peridico. Cambie el modelo o elija el botn 'Cancelar'."
PastRecur,                              "Desea dejar las apariciones pasadas de este elemento en su agenda?"

;Prompt for re-send
ResendToAll,                    "Algunos de los participantes de esta reunin ya han sido notificados. Desea enviarles un nuevo mensaje?"
MeetingMoved,                   "No es posible notificar a los participantes de esta reunin de este cambio, debido a que usted est trabajando sin conexin a la red. Quizs desee deshacer este cambio y hacerlo de nuevo cuando est trabajando con conexin a la red."

; to do messages
ToDoDelProject,                 "Cualquier tarea bajo este proyecto tambin ser eliminada."

; Archive Messages
NoWriteRights,                  "Usted no tiene los privilegios de acceso adecuados para eliminar las citas de este Libro de citas."
ScheduleRightsError,    "Hubo un problema al leer el archivo de agenda."
ArchiveWarnOne,                 "Al archivar este dato como un dato antiguo ste ser quitado permanentemente del archivo de agenda."
ArchiveWarnTwo,                 "Desea archivarlo como dato antiguo de todas maneras?"
ArchiveFileError,               "No fue posible crear el archivo de datos antiguos."
ArchiveNoFile,                  "El archivo no existe."
; Note: ArchiveTitle should have one blank space at the end
ArchiveTitle,                   "Archivar como dato antiguo: "
ArchivingData,                  "Archivando como datos antiguos..."
InvalidArchiveFile,             "El archivo que seleccion no es un archivo de datos antiguos."
ArchiveOldFileVersion,  "Este archivo de datos antiguos est en un formato antiguo."
ArchiveOldFileDelete,   "Est bien eliminar el archivo y continuar?"
ArchiveNewFileVersion,  "Este archivo de datos antiguos fue creado con un versin ms reciente de Schedule+. Por favor, instale la versin ms reciente en su computadora."

; message store error messages
MessageErr                              "Hay un problema con este mensaje. Vea su administrador de correos"

; summary list warning message
SummaryLiveUpdate               "Advertencia: No fue posible hacer una 'ActualizacinEnVivo' de la lista de mensaje "

; message generated if group cannot be expanded to retrieve schedule info
GroupExpandErr,                 "No fue posible determinar completamente los miembros de este grupo."

;Strings for Attendees dialog
UnableToInitAB,                 "Hubo un problema al abrir la Libreta de direcciones."
UnableToResolve,                "'%s' no es un nombre vlido."

;Request Meeting strings
NoAttendees,                    "Debe de seleccionar algunos participantes antes de planificar la reunin."
MeetingBooked,          "La reunin se reserv con xito."
MeetingBookedNoSend,    "La reunin se reserv con xito, pero la convocatoria no se envi."


;Auto-pick strings
NoFreeTime,                     "Los participantes no tienen tiempo disponible en los prximos dos meses. Desea buscar en los prximos dos meses?"

CannotAddConflictErr,           "%s ya tiene una cita reservada a esa hora. Desea reservar esta cita coincidiendo con otra de todos modos?"

;Other mail enabled apps
NoOfflineOther,         "Mail no se puede desconectar de la red."
NoOnlineOther,          "Mail no se puede conectar a la red."
TryCloseOther,          "Quizs desee cerrarlo e intentar de nuevo."
SigninWarnOnline,               "No fue posible iniciar Schedule+ sin conexin a la red debido a que Mail o los Avisos de Schedule+ estn en ejecucin." 

; BUG: move up
AlreadyLogged,          "Alguien ya est registrado como ese usuario."
NoExitOther,            "No fue posible cerrar Mail o los Avisos de Schedule+."
SigninNoFiles,          "No fue posible obtener acceso a sus archivos de agenda."
ErrorGettingUser,       "No es posible recuperar la informacin de %s. Puede existir un problema obteniendo acceso al servidor o %s ya no existe."

;BUG Printer Strings
PrtRangeToBig,			"El rango de impresin especificado se extiende fuera de las fechas apoyadas por Schedule+. Desea imprimir el 31 de Diciembre de 2019?"
ConflictRecurMsg,            "Esta cita peridica estar en conflicto con una cita peridica existente en su agenda. Desea aadirla de todos modos?\n\n"
FirstOccur,				"\nfprimera aparicin en \n"

ApptMoveTooFarInFuture,		"No es posible mover este evento a la fecha que ha seleccionado debido a que sera despus del 31 de Diciembre de 2019."

;BUG: move up next to idsGroupExpandError
GroupNotFound			"No es posible enviar el mensaje a uno o ms de los grupos, debido a que no es posible identificar los miembros del grupo o el nombre del grupo ha sido eliminado."
ErrorGettingSecy		"Error al obtener el asistente."

;BUG: move near other local file stuff
SigninBadLclSchedFile,	"%s no es un archivo local de agenda vlido. Est bien eliminarlo?"
NoMemRecurItems,		"No hay suficiente memoria para mostrar todos los elementos peridicos. Algunos de ellos no sern mostrados."

CompleteAction,			"Una accin en Schedule+ debe de completarse antes de salir."

BadStartWork,           "La hora de inicio de trabajo debe de ser un nmero del 0 al 99."

ConflictSendCanceled,	"Cierre el mensaje de reunin y elija una nueva hora o seleccione diferentes participantes para planificarla de nuevo."
ResourceConflict,	"El recurso %s ya est reservado a esa hora. Cierre el mensaje de reunin y elija una nueva hora o seleccione otro recurso. "

;Recover
AskRecover,				"Su archivo de agenda est daado. Se necesitarn varios minutos para repararlo."
CopyProblem,			"Hubo un problema al copiar su archivo de agenda con conexin a la red. No se restaur el archivo. Libere espacio en el disco en su computadora y ejecute de nuevo Schedule+."
NotRepaired1,			"No se restaur completamente su archivo de agenda. Su archivo de agenda daado fue copiado en %s y el archivo de importacin creado por el proceso de restauracin fue copiado en %s."
NotRepaired2,			"Se ha creado un archivo de agenda nuevo, pero algunos datos pudieron haberse perdido."
Repaired,				"Su archivo ha sido restaurado. Su archivo de agenda antiguo fue copiado en %s."
RepairingLocal,			"Su archivo local se est restaurando."
RestoreOnline,			"Restaurando las citas con conexin a la red..."
RestoreLocal,			"Restaurando las citas locales..."

PasswdDiffOnline,             "Sus contraseas no coinciden. Escriba su contrasea anterior."
ExportDllError,                 "No fue posible cargar un DLL exportador."
NoGroup,				"Hasta que sea ejecutado una vez Mail, no estar en la capacidad de utilizar ninguna de las caractersticas de Schedule+ para grupos de trabajo. Desea usar ahora nicamente las caractersticas personales de Schedule+?"
