/*++ BUILD Version: 0001    // Increment this if a change has global effects

Copyright (c) 1992  Microsoft Corporation

Module Name:

    atkmsg.h

Abstract:

    Definitions for appletalk events.

Author:

    Nikhil Kamkolkar (nikhilk@microsoft.com)

Revision History:

Notes:

    This file is generated by the MC tool from the atkmsg.mc file.

--*/

#ifndef _ATKMSG_
#define _ATKMSG_


/////////////////////////////////////////////////////////////////////////
// Appletalk Events - Start with the DDP upwards and then the glue code
//                    events
//
/////////////////////////////////////////////////////////////////////////


// Don't use %1 for insertion strings -- the I/O system provides the
// first string (device name).

//
//  Values are 32 bit values layed out as follows:
//
//   3 3 2 2 2 2 2 2 2 2 2 2 1 1 1 1 1 1 1 1 1 1
//   1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0
//  +---+-+-+-----------------------+-------------------------------+
//  |Sev|C|R|     Facility          |               Code            |
//  +---+-+-+-----------------------+-------------------------------+
//
//  where
//
//      Sev - is the severity code
//
//          00 - Success
//          01 - Informational
//          10 - Warning
//          11 - Error
//
//      C - is the Customer code flag
//
//      R - is a reserved bit
//
//      Facility - is the facility code
//
//      Code - is the facility's status code
//
//
// Define the facility codes
//


//
// Define the severity codes
//
#define STATUS_SEVERITY_WARNING          0x2
#define STATUS_SEVERITY_SUCCESS          0x0
#define STATUS_SEVERITY_INFORMATIONAL    0x1
#define STATUS_SEVERITY_ERROR            0x3


//
// MessageId: EVENT_ATALK_NAME_REGISTERED
//
// MessageText:
//
//  The AppleTalk router registered the name %2 on the network
//
#define EVENT_ATALK_NAME_REGISTERED      0x400007D0L

//
// MessageId: EVENT_ATALK_RESOURCE_SHORTAGE
//
// MessageText:
//
//  The Appletalk stack was unable to perform an operation due to a shortage of
//  available resources.
//
#define EVENT_ATALK_RESOURCE_SHORTAGE    0xC00007D1L

//
// MessageId: EVENT_ATALK_CANT_CREATE_DEVICE
//
// MessageText:
//
//  Appletalk could not create the device %2.  Appletalk could not be started.
//
#define EVENT_ATALK_CANT_CREATE_DEVICE   0xC00007D2L

//
// MessageId: EVENT_ATALK_UNLOAD
//
// MessageText:
//
//  Appletalk has successfully unloaded.
//
#define EVENT_ATALK_UNLOAD               0x800007D3L


#endif // _ATKMSG

