;/*++ BUILD Version: 0001    // Increment this if a change has global effects
;
;Copyright (c) 1994  Microsoft Corporation
;
;Module Name:
;
;    dhcpmsg.h
;
;Abstract:
;
;    Definitions for DHCP messages.
;
;Author:
;
;    Madan Appiah (madana)  10-Sep-1993
;    Manny Weiser 8-Dec-1992
;
;Revision History:
;
;Notes:
;
;    This file is generated by the MC tool from the dhcpmsg.mc file.
;
;    ?? NOTE : These message should go into winerror.h, until then use a
;    error code range which is not used by the system.
;
;--*/
;
;#ifndef _DHCPMESSAGE_
;#define _DHCPMESSAGE_
;

;//
;//  20000 - 20099   Reserved for DHCP server service specific errors.
;//

MessageId=20000 SymbolicName=ERROR_DHCP_REGISTRY_INIT_FAILED
Language=English
The DHCP server initialization parameters are invalid.
.

MessageId=20001 SymbolicName=ERROR_DHCP_DATABASE_INIT_FAILED
Language=English
The DHCP server was unable to open the DHCP client database.
.

MessageId=20002 SymbolicName=ERROR_DHCP_RPC_INIT_FAILED
Language=English
The DHCP server was unable to start as an RPC server.
.

MessageId=20003 SymbolicName=ERROR_DHCP_NETWORK_INIT_FAILED
Language=English
The DHCP server was unable establish a sockets connection.
.

MessageId=20004 SymbolicName=ERROR_DHCP_SUBNET_EXITS
Language=English
The specified Subnet already exists.
.

MessageId=20005 SymbolicName=ERROR_DHCP_SUBNET_NOT_PRESENT;
Language=English
The specified Subnet does not exist.
.

MessageId=20006 SymbolicName=ERROR_DHCP_PRIMARY_NOT_FOUND
Language=English
The primary host information for the specified subnet was not found.
.

MessageId=20007 SymbolicName=ERROR_DHCP_ELEMENT_CANT_REMOVE
Language=English
The specified DHCP element cannot be removed because it has been used.
.

MessageId=20009 SymbolicName=ERROR_DHCP_OPTION_EXITS
Language=English
The specified option already exists.
.

MessageId=20010 SymbolicName=ERROR_DHCP_OPTION_NOT_PRESENT;
Language=English
The specified option does not exist.
.

MessageId=20011 SymbolicName=ERROR_DHCP_ADDRESS_NOT_AVAILABLE;
Language=English
The specified address is not available.
.

MessageId=20012 SymbolicName=ERROR_DHCP_RANGE_FULL;
Language=English
The specified Range is full.
.

MessageId=20013 SymbolicName=ERROR_DHCP_JET_ERROR;
Language=English
An error occurred while accessing the DHCP database; Look at the
DHCP server event log for more information.
.

MessageId=20014 SymbolicName=ERROR_DHCP_CLIENT_EXISTS;
Language=English
The specified Client already exists in the database.
.

MessageId=20015 SymbolicName=ERROR_DHCP_INVALID_DHCP_MESSAGE;
Language=English
The DHCP server received an invalid message.
.

MessageId=20016 SymbolicName=ERROR_DHCP_INVALID_DHCP_CLIENT;
Language=English
The DHCP server received a message from an invalid client.
.

MessageId=20017 SymbolicName=ERROR_DHCP_SERVICE_PAUSED;
Language=English
The DHCP server service is paused.
.

MessageId=20018 SymbolicName=ERROR_DHCP_NOT_RESERVED_CLIENT;
Language=English
The specified client is not a reserved client.
.

MessageId=20019 SymbolicName=ERROR_DHCP_RESERVED_CLIENT;
Language=English
The specified client is a reserved client.
.

MessageId=20020 SymbolicName=ERROR_DHCP_RANGE_TOO_SMALL;
Language=English
The specified IpRange is too small.
.

MessageId=20021 SymbolicName=ERROR_DHCP_IPRANGE_EXITS;
Language=English
The specified IpRange already exists.
.

MessageId=20022 SymbolicName=ERROR_DHCP_RESERVEDIP_EXITS;
Language=English
The specified IP address is already used by another client.
.

MessageId=20023 SymbolicName=ERROR_DHCP_INVALID_RANGE;
Language=English
The specified range either overlaps with an already existing range or is
invalid.
.

MessageId=20024 SymbolicName=ERROR_DHCP_RANGE_EXTENDED;
Language=English
The specified range is extension of an already existing range.
.

;//
;//  1000 - 1099   Reserved for DHCP server events.
;//

MessageId=1000 SymbolicName=EVENT_SERVER_UNKNOWN_OPTION
Language=English
The DHCP Server received an unknown option %1 of length %2. The raw option
data is given below.
.

MessageId=1001 SymbolicName=EVENT_SERVER_FAILED_REGISTER_SC
Language=English
The DHCP Server failed to register with Service Controller. The
following error occurred: %n%1.
.

MessageId=1002 SymbolicName=EVENT_SERVER_INIT_DATA_FAILED
Language=English
The DHCP server failed to initialize its global data. The following
error occurred: %n%1
.

MessageId=1003 SymbolicName=EVENT_SERVER_INIT_REGISTRY_FAILED
Language=English
The DHCP server failed to initialize its registry data. The following
error occurred: %n%1
.

MessageId=1004 SymbolicName=EVENT_SERVER_INIT_DATABASE_FAILED
Language=English
The DHCP server failed to initialize the database. The following
error occurred: %n%1
.

MessageId=1005 SymbolicName=EVENT_SERVER_INIT_WINSOCK_FAILED
Language=English
The DHCP server failed to initialize Winsock startup. The following
error occurred: %n%1
.

MessageId=1006 SymbolicName=EVENT_SERVER_INIT_RPC_FAILED
Language=English
The DHCP Server Failed to start the RPC server. The following error
occurred : %n%1
.

MessageId=1007 SymbolicName=EVENT_SERVER_INIT_SOCK_FAILED
Language=English
The DHCP server failed to initialize winsock data. The following
error occurred: %n%1
.

MessageId=1008 SymbolicName=EVENT_SERVER_SHUTDOWN
Language=English
The DHCP server is shutting down due to the following error: %n%1
.

MessageId=1009 SymbolicName=EVENT_SERVER_CLIENT_CLEANUP
Language=English
The DHCP server encountered the following error when cleaning up the
pending user records: %n%1
.

MessageId=1010 SymbolicName=EVENT_SERVER_DATABASE_CLEANUP
Language=English
The DHCP server encoutered the following error when cleaning up the user
database: %n%1
.

MessageId=1011 SymbolicName=EVENT_SERVER_LEASE_NACK
Language=English
The DHCP server issued a NACK to the client (%2) for the address (%1)
request.
.

MessageId=1012 SymbolicName=EVENT_SERVER_LEASE_DECLINED
Language=English
The DHCP Client (%2) declined the address (%1).
.

MessageId=1013 SymbolicName=EVENT_SERVER_LEASE_RELEASE
Language=English
The DHCP Client (%2) released the address (%1).
.

MessageId=1014 SymbolicName=EVENT_SERVER_JET_ERROR
Language=English
The JET Database call returned the following Error : %1.
.

MessageId=1015 SymbolicName=EVENT_SERVER_JET_WARNING
Language=English
The JET Database call returned the following Warning : %1.
.

MessageId=1016 SymbolicName=EVENT_SERVER_DATABASE_BACKUP
Language=English
The DHCP server encoutered the following error when backing up the
user database: %n%1
.

MessageId=1017 SymbolicName=EVENT_SERVER_CONFIG_BACKUP
Language=English
The DHCP server encoutered the following error when backing up the
registry configuration: %n%1
.

MessageId=1018 SymbolicName=EVENT_SERVER_DATABASE_RESTORE_FAILED
Language=English
The DHCP server failed to restore the database. The following
error occurred: %n%1
.

MessageId=1019 SymbolicName=EVENT_SERVER_CONFIG_RESTORE_FAILED
Language=English
The DHCP server failed to restore the dhcp registry configuration. The
following error occurred: %n%1
.
MessageId=1020 SymbolicName=EVENT_SERVER_LOW_ADDRESS_WARNING
Language=English
Scope %1 is %2 percent utilized with only %3 IP addresses remaining.
.

;#endif // _DHCPMESSAGE_

