/**********************************************************************/
/**                       Microsoft Windows/NT                       **/
/**                Copyright(c) Microsoft Corp., 1991                **/
/**********************************************************************/

/*
    bltmain.cxx
    BLT application startup code

    This file contains the C-linkage glue functions binding BLT to
    the application.


    FILE HISTORY:
        beng        01-Apr-1991     Created

*/

#include "pchblt.hxx"

/*******************************************************************

    NAME:       BltMain

    SYNOPSIS:   Glue function binding BLT to the application.

    NOTES:
        BltMain is generated by the SET_ROOT_OBJECT macro.  This
        implementation will only link into the application if the
        client neglected to set a root object.

    HISTORY:
        beng        01-Apr-1991 Created
        beng        14-Oct-1991 APPSTART deleted; now used to detect
                                a missing root object
        beng        24-Apr-1992 Removed pszCmdLine parameter

********************************************************************/

INT BltMain(
    HINSTANCE   hInstance,       // current instance
    HINSTANCE   hPrevInstance,   // previous instance
    INT      nCmdShow )       // show-window type (open/icon)
{
    UNREFERENCED(hInstance);
    UNREFERENCED(hPrevInstance);
    UNREFERENCED(nCmdShow);

    ::MessageBox(NULL, SZ("Client application never declared a root object"),
                 SZ("BLT"), (MB_TASKMODAL | MB_ICONSTOP | MB_OK) );

    return 0;
}
