/**********************************************************************/
/**                       Microsoft Windows NT                       **/
/**                Copyright(c) Microsoft Corp., 1993                **/
/**********************************************************************/

/*
    wsockmsg.h

    This file is generated by the MC tool from the CKMMSG.MC message
    file.

*/


#ifndef _WSOCKMSG_H_
#define _WSOCKMSG_H_

//
//  Values are 32 bit values layed out as follows:
//
//   3 3 2 2 2 2 2 2 2 2 2 2 1 1 1 1 1 1 1 1 1 1
//   1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0
//  +---+-+-+-----------------------+-------------------------------+
//  |Sev|C|R|     Facility          |               Code            |
//  +---+-+-+-----------------------+-------------------------------+
//
//  where
//
//      Sev - is the severity code
//
//          00 - Success
//          01 - Informational
//          10 - Warning
//          11 - Error
//
//      C - is the Customer code flag
//
//      R - is a reserved bit
//
//      Facility - is the facility code
//
//      Code - is the facility's status code
//
//
// Define the facility codes
//


//
// Define the severity codes
//


//
// MessageId: WSA_ERR_EINTR
//
// MessageText:
//
//  Interrupted system call.
//
#define WSA_ERR_EINTR                    0x00002714L

//
// MessageId: WSA_ERR_EBADF
//
// MessageText:
//
//  Bad file number.
//
#define WSA_ERR_EBADF                    0x00002719L

//
// MessageId: WSA_ERR_EACCES
//
// MessageText:
//
//  Access denied.
//
#define WSA_ERR_EACCES                   0x0000271DL

//
// MessageId: WSA_ERR_EFAULT
//
// MessageText:
//
//  Bad address.
//
#define WSA_ERR_EFAULT                   0x0000271EL

//
// MessageId: WSA_ERR_EINVAL
//
// MessageText:
//
//  Invalid argument.
//
#define WSA_ERR_EINVAL                   0x00002726L

//
// MessageId: WSA_ERR_EMFILE
//
// MessageText:
//
//  Too many open files.
//
#define WSA_ERR_EMFILE                   0x00002728L

//
// MessageId: WSA_ERR_EWOULDBLOCK
//
// MessageText:
//
//  Operation would block.
//
#define WSA_ERR_EWOULDBLOCK              0x00002733L

//
// MessageId: WSA_ERR_EINPROGRESS
//
// MessageText:
//
//  Operation now in progress.
//
#define WSA_ERR_EINPROGRESS              0x00002734L

//
// MessageId: WSA_ERR_EALREADY
//
// MessageText:
//
//  Operation already in progress.
//
#define WSA_ERR_EALREADY                 0x00002735L

//
// MessageId: WSA_ERR_ENOTSOCK
//
// MessageText:
//
//  Socket operation on non-socket.
//
#define WSA_ERR_ENOTSOCK                 0x00002736L

//
// MessageId: WSA_ERR_EDESTADDRREQ
//
// MessageText:
//
//  Destination address required.
//
#define WSA_ERR_EDESTADDRREQ             0x00002737L

//
// MessageId: WSA_ERR_EMSGSIZE
//
// MessageText:
//
//  Message too long.
//
#define WSA_ERR_EMSGSIZE                 0x00002738L

//
// MessageId: WSA_ERR_EPROTOTYPE
//
// MessageText:
//
//  Protocol is wrong type for socket.
//
#define WSA_ERR_EPROTOTYPE               0x00002739L

//
// MessageId: WSA_ERR_ENOPROTOOPT
//
// MessageText:
//
//  Bad protocol option.
//
#define WSA_ERR_ENOPROTOOPT              0x0000273AL

//
// MessageId: WSA_ERR_EPROTONOSUPPORT
//
// MessageText:
//
//  Protocol not supported.
//
#define WSA_ERR_EPROTONOSUPPORT          0x0000273BL

//
// MessageId: WSA_ERR_ESOCKNOSUPPORT
//
// MessageText:
//
//  Socket type not supported.
//
#define WSA_ERR_ESOCKNOSUPPORT           0x0000273CL

//
// MessageId: WSA_ERR_EOPNOTSUPP
//
// MessageText:
//
//  Operation not supported on socket.
//
#define WSA_ERR_EOPNOTSUPP               0x0000273DL

//
// MessageId: WSA_ERR_EPFNOSUPPORT
//
// MessageText:
//
//  Protocol family not supported.
//
#define WSA_ERR_EPFNOSUPPORT             0x0000273EL

//
// MessageId: WSA_ERR_EAFNOSUPPORT
//
// MessageText:
//
//  Address family not supported by protocol family.
//
#define WSA_ERR_EAFNOSUPPORT             0x0000273FL

//
// MessageId: WSA_ERR_EADDRINUSE
//
// MessageText:
//
//  Address already in use.
//
#define WSA_ERR_EADDRINUSE               0x00002740L

//
// MessageId: WSA_ERR_EADDRNOTAVAIL
//
// MessageText:
//
//  Can't assign requested address.
//
#define WSA_ERR_EADDRNOTAVAIL            0x00002741L

//
// MessageId: WSA_ERR_ENETDOWN
//
// MessageText:
//
//  Network is down.
//
#define WSA_ERR_ENETDOWN                 0x00002742L

//
// MessageId: WSA_ERR_ENETUNREACH
//
// MessageText:
//
//  ICMP network unreachable.
//
#define WSA_ERR_ENETUNREACH              0x00002743L

//
// MessageId: WSA_ERR_ENETRESET
//
// MessageText:
//
//  Network was reset.
//
#define WSA_ERR_ENETRESET                0x00002744L

//
// MessageId: WSA_ERR_ECONNABORTED
//
// MessageText:
//
//  Software caused connection abort.
//
#define WSA_ERR_ECONNABORTED             0x00002745L

//
// MessageId: WSA_ERR_ECONNRESET
//
// MessageText:
//
//  Connection reset by peer.
//
#define WSA_ERR_ECONNRESET               0x00002746L

//
// MessageId: WSA_ERR_ENOBUFS
//
// MessageText:
//
//  No buffer space is supported.
//
#define WSA_ERR_ENOBUFS                  0x00002747L

//
// MessageId: WSA_ERR_EISCONN
//
// MessageText:
//
//  Socket is already connected.
//
#define WSA_ERR_EISCONN                  0x00002748L

//
// MessageId: WSA_ERR_ENOTCONN
//
// MessageText:
//
//  Socket is not connected.
//
#define WSA_ERR_ENOTCONN                 0x00002749L

//
// MessageId: WSA_ERR_ESHUTDOWN
//
// MessageText:
//
//  Can't send after socket shutdown.
//
#define WSA_ERR_ESHUTDOWN                0x0000274AL

//
// MessageId: WSA_ERR_ETOOMANYREFS
//
// MessageText:
//
//  Too many references.
//
#define WSA_ERR_ETOOMANYREFS             0x0000274BL

//
// MessageId: WSA_ERR_ETIMEDOUT
//
// MessageText:
//
//  Connection timed out.
//
#define WSA_ERR_ETIMEDOUT                0x0000274CL

//
// MessageId: WSA_ERR_ECONNREFUSED
//
// MessageText:
//
//  Connection refused.
//
#define WSA_ERR_ECONNREFUSED             0x0000274DL

//
// MessageId: WSA_ERR_ELOOP
//
// MessageText:
//
//  Too many levels of symbolic links.
//
#define WSA_ERR_ELOOP                    0x0000274EL

//
// MessageId: WSA_ERR_ENAMETOOLONG
//
// MessageText:
//
//  Name too long.
//
#define WSA_ERR_ENAMETOOLONG             0x0000274FL

//
// MessageId: WSA_ERR_EHOSTDOWN
//
// MessageText:
//
//  Host is down.
//
#define WSA_ERR_EHOSTDOWN                0x00002750L

//
// MessageId: WSA_ERR_EHOSTUNREACH
//
// MessageText:
//
//  Host is unreachable.
//
#define WSA_ERR_EHOSTUNREACH             0x00002751L

//
// MessageId: WSA_ERR_ENOTEMPTY
//
// MessageText:
//
//  Directory not empty.
//
#define WSA_ERR_ENOTEMPTY                0x00002752L

//
// MessageId: WSA_ERR_EPROCLIM
//
// MessageText:
//
//  EPROCLIM returned.
//
#define WSA_ERR_EPROCLIM                 0x00002753L

//
// MessageId: WSA_ERR_EUSERS
//
// MessageText:
//
//  EUSERS returned.
//
#define WSA_ERR_EUSERS                   0x00002754L

//
// MessageId: WSA_ERR_EDQUOT
//
// MessageText:
//
//  Disk quota exceeded.
//
#define WSA_ERR_EDQUOT                   0x00002755L

//
// MessageId: WSA_ERR_ESTALE
//
// MessageText:
//
//  ESTALE returned.
//
#define WSA_ERR_ESTALE                   0x00002756L

//
// MessageId: WSA_ERR_EREMOTE
//
// MessageText:
//
//  The object is remote.
//
#define WSA_ERR_EREMOTE                  0x00002757L

//
// MessageId: WSA_ERR_SYSNOTREADY
//
// MessageText:
//
//  System not ready.
//
#define WSA_ERR_SYSNOTREADY              0x0000276BL

//
// MessageId: WSA_ERR_VERNOTSUPPORTED
//
// MessageText:
//
//  Version is not supported.
//
#define WSA_ERR_VERNOTSUPPORTED          0x0000276CL

//
// MessageId: WSA_ERR_NOTINITIALISED
//
// MessageText:
//
//  Not initialized.
//
#define WSA_ERR_NOTINITIALISED           0x0000276DL

//
// MessageId: WSA_ERR_EDISCON
//
// MessageText:
//
//  Disconnected.
//
#define WSA_ERR_EDISCON                  0x00002775L

//
// MessageId: WSA_ERR_HOST_NOT_FOUND
//
// MessageText:
//
//  Host not found.
//
#define WSA_ERR_HOST_NOT_FOUND           0x00002AF9L

//
// MessageId: WSA_ERR_TRY_AGAIN
//
// MessageText:
//
//  Try again.
//
#define WSA_ERR_TRY_AGAIN                0x00002AFAL

//
// MessageId: WSA_ERR_NO_RECOVERY
//
// MessageText:
//
//  Non-recoverable error.
//
#define WSA_ERR_NO_RECOVERY              0x00002AFBL

//
// MessageId: WSA_ERR_NO_DATA
//
// MessageText:
//
//  No data record available.
//
#define WSA_ERR_NO_DATA                  0x00002AFCL


#endif  // _WSOCKMSG_H_

