/*
** Copyright 1991-1993, Silicon Graphics, Inc.
** All Rights Reserved.
** 
** This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
** the contents of this file may not be disclosed to third parties, copied or
** duplicated in any form, in whole or in part, without the prior written
** permission of Silicon Graphics, Inc.
** 
** RESTRICTED RIGHTS LEGEND:
** Use, duplication or disclosure by the Government is subject to restrictions
** as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
** and Computer Software clause at DFARS 252.227-7013, and/or in similar or
** successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
** rights reserved under the Copyright Laws of the United States.
*/


/*
 * AUTOMATICALLY UPDATED OR GENERATED BY SGI: DO NOT EDIT
 * IF YOU MUST MODIFY THIS FILE, PLEASE CONTACT ptar@sgi.com 415-390-1483
 */

#define const           // Don't bother with const

#include <nt.h>
#include <ntrtl.h>
#include <nturtl.h>
#include <string.h>
#include <stddef.h>
#include <windows.h>
#include <winddi.h>
#include <GL/gl.h>

#include "glsbmsg.h"
#include "glsbmsgh.h"

#include "batchinf.h"
#include "glteb.h"
#include "glsrvu.h"
#include "gencx.h"
#include "debug.h"

VOID *
sbs_glNewList ( IN GLMSG_NEWLIST *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.NewList)( pMsg->list, pMsg->mode );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glEndList ( IN GLMSG_ENDLIST *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.EndList)( );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glCallList ( IN GLMSG_CALLLIST *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.CallList)( pMsg->list );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glCallLists ( IN GLMSG_CALLLISTS *pMsg )
{

// VARIABLE_IN

    VOID *pData;
    BOOL Large = FALSE;
    VOID *NextOffset;
    __GLcontext *gc;

    NextOffset = (VOID *) ( ((BYTE *)pMsg) + pMsg->MsgSize );

    if ( pMsg->DataSize )
    {
        if ( pMsg->listsOff )
        {
            Large = TRUE;

            if ( NULL == (pData = __wglTempAlloc(gc = __gl_context, pMsg->DataSize )) )
            {
                DBGERROR("__wglTempAlloc failed\n");
                return( NextOffset );
            }
            else
            {
                if ( FALSE == glsrvuCopyClientData(
                        pData,
                        (VOID *)pMsg->listsOff,
                        pMsg->DataSize )
                   )
                {
                    __glSetError(GL_INVALID_VALUE);
                    DBGERROR("glsrvuCopyClientData failed\n");
                    __wglTempFree(gc, pData );
                    return( NextOffset );
                }
            }
        }
        else
        {
            pData = (VOID *)((BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)));
        }
    }
    else
    {
        pData = NULL;
    }

    (*GLTEB_SRVDISPATCHTABLE->dispatch.CallLists)( pMsg->n, pMsg->type, pData );

    if ( Large )
    {
        __wglTempFree(gc, pData );
    }

    return( NextOffset );
}

VOID *
sbs_glDeleteLists ( IN GLMSG_DELETELISTS *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.DeleteLists)( pMsg->list, pMsg->range );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glGenLists ( IN GLMSG_GENLISTS *pMsg )
{
    GLTEB_SRVRETURNVALUE =
        (ULONG)(*GLTEB_SRVDISPATCHTABLE->dispatch.GenLists)( pMsg->range );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glListBase ( IN GLMSG_LISTBASE *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.ListBase)( pMsg->base );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glBegin ( IN GLMSG_BEGIN *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.Begin)( pMsg->mode );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glColor3b ( IN GLMSG_COLOR3B *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->color.Color3b)( pMsg->red, pMsg->green, pMsg->blue );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glColor3bv ( IN GLMSG_COLOR3BV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->color.Color3bv)( pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glColor3d ( IN GLMSG_COLOR3D *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->color.Color3d)( pMsg->red, pMsg->green, pMsg->blue );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glColor3dv ( IN GLMSG_COLOR3DV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->color.Color3dv)( pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glColor3f ( IN GLMSG_COLOR3F *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->color.Color3f)( pMsg->red, pMsg->green, pMsg->blue );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glColor3fv ( IN GLMSG_COLOR3FV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->color.Color3fv)( pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glColor3i ( IN GLMSG_COLOR3I *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->color.Color3i)( pMsg->red, pMsg->green, pMsg->blue );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glColor3iv ( IN GLMSG_COLOR3IV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->color.Color3iv)( pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glColor3s ( IN GLMSG_COLOR3S *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->color.Color3s)( pMsg->red, pMsg->green, pMsg->blue );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glColor3sv ( IN GLMSG_COLOR3SV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->color.Color3sv)( pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glColor3ub ( IN GLMSG_COLOR3UB *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->color.Color3ub)( pMsg->red, pMsg->green, pMsg->blue );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glColor3ubv ( IN GLMSG_COLOR3UBV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->color.Color3ubv)( pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glColor3ui ( IN GLMSG_COLOR3UI *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->color.Color3ui)( pMsg->red, pMsg->green, pMsg->blue );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glColor3uiv ( IN GLMSG_COLOR3UIV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->color.Color3uiv)( pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glColor3us ( IN GLMSG_COLOR3US *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->color.Color3us)( pMsg->red, pMsg->green, pMsg->blue );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glColor3usv ( IN GLMSG_COLOR3USV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->color.Color3usv)( pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glColor4b ( IN GLMSG_COLOR4B *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->color.Color4b)( pMsg->red, pMsg->green, pMsg->blue, pMsg->alpha );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glColor4bv ( IN GLMSG_COLOR4BV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->color.Color4bv)( pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glColor4d ( IN GLMSG_COLOR4D *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->color.Color4d)( pMsg->red, pMsg->green, pMsg->blue, pMsg->alpha );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glColor4dv ( IN GLMSG_COLOR4DV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->color.Color4dv)( pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glColor4f ( IN GLMSG_COLOR4F *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->color.Color4f)( pMsg->red, pMsg->green, pMsg->blue, pMsg->alpha );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glColor4fv ( IN GLMSG_COLOR4FV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->color.Color4fv)( pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glColor4i ( IN GLMSG_COLOR4I *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->color.Color4i)( pMsg->red, pMsg->green, pMsg->blue, pMsg->alpha );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glColor4iv ( IN GLMSG_COLOR4IV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->color.Color4iv)( pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glColor4s ( IN GLMSG_COLOR4S *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->color.Color4s)( pMsg->red, pMsg->green, pMsg->blue, pMsg->alpha );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glColor4sv ( IN GLMSG_COLOR4SV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->color.Color4sv)( pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glColor4ub ( IN GLMSG_COLOR4UB *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->color.Color4ub)( pMsg->red, pMsg->green, pMsg->blue, pMsg->alpha );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glColor4ubv ( IN GLMSG_COLOR4UBV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->color.Color4ubv)( pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glColor4ui ( IN GLMSG_COLOR4UI *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->color.Color4ui)( pMsg->red, pMsg->green, pMsg->blue, pMsg->alpha );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glColor4uiv ( IN GLMSG_COLOR4UIV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->color.Color4uiv)( pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glColor4us ( IN GLMSG_COLOR4US *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->color.Color4us)( pMsg->red, pMsg->green, pMsg->blue, pMsg->alpha );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glColor4usv ( IN GLMSG_COLOR4USV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->color.Color4usv)( pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glEdgeFlag ( IN GLMSG_EDGEFLAG *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.EdgeFlag)( pMsg->flag );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glEdgeFlagv ( IN GLMSG_EDGEFLAGV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.EdgeFlagv)( pMsg->flag );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glEnd ( IN GLMSG_END *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.End)( );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glIndexd ( IN GLMSG_INDEXD *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->color.Indexd)( pMsg->c );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glIndexdv ( IN GLMSG_INDEXDV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->color.Indexdv)( pMsg->c );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glIndexf ( IN GLMSG_INDEXF *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->color.Indexf)( pMsg->c );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glIndexfv ( IN GLMSG_INDEXFV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->color.Indexfv)( pMsg->c );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glIndexi ( IN GLMSG_INDEXI *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->color.Indexi)( pMsg->c );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glIndexiv ( IN GLMSG_INDEXIV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->color.Indexiv)( pMsg->c );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glIndexs ( IN GLMSG_INDEXS *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->color.Indexs)( pMsg->c );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glIndexsv ( IN GLMSG_INDEXSV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->color.Indexsv)( pMsg->c );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glNormal3b ( IN GLMSG_NORMAL3B *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->normal.Normal3b)( pMsg->nx, pMsg->ny, pMsg->nz );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glNormal3bv ( IN GLMSG_NORMAL3BV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->normal.Normal3bv)( pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glNormal3d ( IN GLMSG_NORMAL3D *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->normal.Normal3d)( pMsg->nx, pMsg->ny, pMsg->nz );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glNormal3dv ( IN GLMSG_NORMAL3DV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->normal.Normal3dv)( pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glNormal3f ( IN GLMSG_NORMAL3F *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->normal.Normal3f)( pMsg->nx, pMsg->ny, pMsg->nz );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glNormal3fv ( IN GLMSG_NORMAL3FV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->normal.Normal3fv)( pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glNormal3i ( IN GLMSG_NORMAL3I *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->normal.Normal3i)( pMsg->nx, pMsg->ny, pMsg->nz );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glNormal3iv ( IN GLMSG_NORMAL3IV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->normal.Normal3iv)( pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glNormal3s ( IN GLMSG_NORMAL3S *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->normal.Normal3s)( pMsg->nx, pMsg->ny, pMsg->nz );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glNormal3sv ( IN GLMSG_NORMAL3SV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->normal.Normal3sv)( pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glRasterPos2d ( IN GLMSG_RASTERPOS2D *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->rasterPos.RasterPos2d)( pMsg->x, pMsg->y );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glRasterPos2dv ( IN GLMSG_RASTERPOS2DV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->rasterPos.RasterPos2dv)( pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glRasterPos2f ( IN GLMSG_RASTERPOS2F *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->rasterPos.RasterPos2f)( pMsg->x, pMsg->y );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glRasterPos2fv ( IN GLMSG_RASTERPOS2FV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->rasterPos.RasterPos2fv)( pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glRasterPos2i ( IN GLMSG_RASTERPOS2I *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->rasterPos.RasterPos2i)( pMsg->x, pMsg->y );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glRasterPos2iv ( IN GLMSG_RASTERPOS2IV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->rasterPos.RasterPos2iv)( pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glRasterPos2s ( IN GLMSG_RASTERPOS2S *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->rasterPos.RasterPos2s)( pMsg->x, pMsg->y );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glRasterPos2sv ( IN GLMSG_RASTERPOS2SV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->rasterPos.RasterPos2sv)( pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glRasterPos3d ( IN GLMSG_RASTERPOS3D *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->rasterPos.RasterPos3d)( pMsg->x, pMsg->y, pMsg->z );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glRasterPos3dv ( IN GLMSG_RASTERPOS3DV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->rasterPos.RasterPos3dv)( pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glRasterPos3f ( IN GLMSG_RASTERPOS3F *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->rasterPos.RasterPos3f)( pMsg->x, pMsg->y, pMsg->z );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glRasterPos3fv ( IN GLMSG_RASTERPOS3FV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->rasterPos.RasterPos3fv)( pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glRasterPos3i ( IN GLMSG_RASTERPOS3I *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->rasterPos.RasterPos3i)( pMsg->x, pMsg->y, pMsg->z );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glRasterPos3iv ( IN GLMSG_RASTERPOS3IV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->rasterPos.RasterPos3iv)( pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glRasterPos3s ( IN GLMSG_RASTERPOS3S *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->rasterPos.RasterPos3s)( pMsg->x, pMsg->y, pMsg->z );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glRasterPos3sv ( IN GLMSG_RASTERPOS3SV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->rasterPos.RasterPos3sv)( pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glRasterPos4d ( IN GLMSG_RASTERPOS4D *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->rasterPos.RasterPos4d)( pMsg->x, pMsg->y, pMsg->z, pMsg->w );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glRasterPos4dv ( IN GLMSG_RASTERPOS4DV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->rasterPos.RasterPos4dv)( pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glRasterPos4f ( IN GLMSG_RASTERPOS4F *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->rasterPos.RasterPos4f)( pMsg->x, pMsg->y, pMsg->z, pMsg->w );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glRasterPos4fv ( IN GLMSG_RASTERPOS4FV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->rasterPos.RasterPos4fv)( pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glRasterPos4i ( IN GLMSG_RASTERPOS4I *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->rasterPos.RasterPos4i)( pMsg->x, pMsg->y, pMsg->z, pMsg->w );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glRasterPos4iv ( IN GLMSG_RASTERPOS4IV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->rasterPos.RasterPos4iv)( pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glRasterPos4s ( IN GLMSG_RASTERPOS4S *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->rasterPos.RasterPos4s)( pMsg->x, pMsg->y, pMsg->z, pMsg->w );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glRasterPos4sv ( IN GLMSG_RASTERPOS4SV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->rasterPos.RasterPos4sv)( pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glRectd ( IN GLMSG_RECTD *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->rect.Rectd)( pMsg->x1, pMsg->y1, pMsg->x2, pMsg->y2 );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glRectdv ( IN GLMSG_RECTDV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->rect.Rectdv)( pMsg->v1, pMsg->v2 );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glRectf ( IN GLMSG_RECTF *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->rect.Rectf)( pMsg->x1, pMsg->y1, pMsg->x2, pMsg->y2 );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glRectfv ( IN GLMSG_RECTFV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->rect.Rectfv)( pMsg->v1, pMsg->v2 );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glRecti ( IN GLMSG_RECTI *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->rect.Recti)( pMsg->x1, pMsg->y1, pMsg->x2, pMsg->y2 );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glRectiv ( IN GLMSG_RECTIV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->rect.Rectiv)( pMsg->v1, pMsg->v2 );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glRects ( IN GLMSG_RECTS *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->rect.Rects)( pMsg->x1, pMsg->y1, pMsg->x2, pMsg->y2 );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glRectsv ( IN GLMSG_RECTSV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->rect.Rectsv)( pMsg->v1, pMsg->v2 );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glTexCoord1d ( IN GLMSG_TEXCOORD1D *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->texCoord.TexCoord1d)( pMsg->s );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glTexCoord1dv ( IN GLMSG_TEXCOORD1DV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->texCoord.TexCoord1dv)( pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glTexCoord1f ( IN GLMSG_TEXCOORD1F *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->texCoord.TexCoord1f)( pMsg->s );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glTexCoord1fv ( IN GLMSG_TEXCOORD1FV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->texCoord.TexCoord1fv)( pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glTexCoord1i ( IN GLMSG_TEXCOORD1I *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->texCoord.TexCoord1i)( pMsg->s );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glTexCoord1iv ( IN GLMSG_TEXCOORD1IV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->texCoord.TexCoord1iv)( pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glTexCoord1s ( IN GLMSG_TEXCOORD1S *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->texCoord.TexCoord1s)( pMsg->s );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glTexCoord1sv ( IN GLMSG_TEXCOORD1SV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->texCoord.TexCoord1sv)( pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glTexCoord2d ( IN GLMSG_TEXCOORD2D *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->texCoord.TexCoord2d)( pMsg->s, pMsg->t );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glTexCoord2dv ( IN GLMSG_TEXCOORD2DV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->texCoord.TexCoord2dv)( pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glTexCoord2f ( IN GLMSG_TEXCOORD2F *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->texCoord.TexCoord2f)( pMsg->s, pMsg->t );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glTexCoord2fv ( IN GLMSG_TEXCOORD2FV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->texCoord.TexCoord2fv)( pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glTexCoord2i ( IN GLMSG_TEXCOORD2I *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->texCoord.TexCoord2i)( pMsg->s, pMsg->t );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glTexCoord2iv ( IN GLMSG_TEXCOORD2IV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->texCoord.TexCoord2iv)( pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glTexCoord2s ( IN GLMSG_TEXCOORD2S *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->texCoord.TexCoord2s)( pMsg->s, pMsg->t );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glTexCoord2sv ( IN GLMSG_TEXCOORD2SV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->texCoord.TexCoord2sv)( pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glTexCoord3d ( IN GLMSG_TEXCOORD3D *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->texCoord.TexCoord3d)( pMsg->s, pMsg->t, pMsg->r );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glTexCoord3dv ( IN GLMSG_TEXCOORD3DV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->texCoord.TexCoord3dv)( pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glTexCoord3f ( IN GLMSG_TEXCOORD3F *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->texCoord.TexCoord3f)( pMsg->s, pMsg->t, pMsg->r );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glTexCoord3fv ( IN GLMSG_TEXCOORD3FV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->texCoord.TexCoord3fv)( pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glTexCoord3i ( IN GLMSG_TEXCOORD3I *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->texCoord.TexCoord3i)( pMsg->s, pMsg->t, pMsg->r );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glTexCoord3iv ( IN GLMSG_TEXCOORD3IV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->texCoord.TexCoord3iv)( pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glTexCoord3s ( IN GLMSG_TEXCOORD3S *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->texCoord.TexCoord3s)( pMsg->s, pMsg->t, pMsg->r );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glTexCoord3sv ( IN GLMSG_TEXCOORD3SV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->texCoord.TexCoord3sv)( pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glTexCoord4d ( IN GLMSG_TEXCOORD4D *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->texCoord.TexCoord4d)( pMsg->s, pMsg->t, pMsg->r, pMsg->q );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glTexCoord4dv ( IN GLMSG_TEXCOORD4DV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->texCoord.TexCoord4dv)( pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glTexCoord4f ( IN GLMSG_TEXCOORD4F *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->texCoord.TexCoord4f)( pMsg->s, pMsg->t, pMsg->r, pMsg->q );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glTexCoord4fv ( IN GLMSG_TEXCOORD4FV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->texCoord.TexCoord4fv)( pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glTexCoord4i ( IN GLMSG_TEXCOORD4I *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->texCoord.TexCoord4i)( pMsg->s, pMsg->t, pMsg->r, pMsg->q );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glTexCoord4iv ( IN GLMSG_TEXCOORD4IV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->texCoord.TexCoord4iv)( pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glTexCoord4s ( IN GLMSG_TEXCOORD4S *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->texCoord.TexCoord4s)( pMsg->s, pMsg->t, pMsg->r, pMsg->q );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glTexCoord4sv ( IN GLMSG_TEXCOORD4SV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->texCoord.TexCoord4sv)( pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glVertex2d ( IN GLMSG_VERTEX2D *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->vertex.Vertex2d)( pMsg->x, pMsg->y );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glVertex2dv ( IN GLMSG_VERTEX2DV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->vertex.Vertex2dv)( pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glVertex2f ( IN GLMSG_VERTEX2F *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->vertex.Vertex2f)( pMsg->x, pMsg->y );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glVertex2fv ( IN GLMSG_VERTEX2FV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->vertex.Vertex2fv)( pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glVertex2i ( IN GLMSG_VERTEX2I *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->vertex.Vertex2i)( pMsg->x, pMsg->y );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glVertex2iv ( IN GLMSG_VERTEX2IV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->vertex.Vertex2iv)( pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glVertex2s ( IN GLMSG_VERTEX2S *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->vertex.Vertex2s)( pMsg->x, pMsg->y );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glVertex2sv ( IN GLMSG_VERTEX2SV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->vertex.Vertex2sv)( pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glVertex3d ( IN GLMSG_VERTEX3D *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->vertex.Vertex3d)( pMsg->x, pMsg->y, pMsg->z );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glVertex3dv ( IN GLMSG_VERTEX3DV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->vertex.Vertex3dv)( pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glVertex3f ( IN GLMSG_VERTEX3F *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->vertex.Vertex3f)( pMsg->x, pMsg->y, pMsg->z );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glVertex3fv ( IN GLMSG_VERTEX3FV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->vertex.Vertex3fv)( pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glVertex3i ( IN GLMSG_VERTEX3I *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->vertex.Vertex3i)( pMsg->x, pMsg->y, pMsg->z );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glVertex3iv ( IN GLMSG_VERTEX3IV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->vertex.Vertex3iv)( pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glVertex3s ( IN GLMSG_VERTEX3S *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->vertex.Vertex3s)( pMsg->x, pMsg->y, pMsg->z );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glVertex3sv ( IN GLMSG_VERTEX3SV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->vertex.Vertex3sv)( pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glVertex4d ( IN GLMSG_VERTEX4D *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->vertex.Vertex4d)( pMsg->x, pMsg->y, pMsg->z, pMsg->w );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glVertex4dv ( IN GLMSG_VERTEX4DV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->vertex.Vertex4dv)( pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glVertex4f ( IN GLMSG_VERTEX4F *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->vertex.Vertex4f)( pMsg->x, pMsg->y, pMsg->z, pMsg->w );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glVertex4fv ( IN GLMSG_VERTEX4FV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->vertex.Vertex4fv)( pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glVertex4i ( IN GLMSG_VERTEX4I *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->vertex.Vertex4i)( pMsg->x, pMsg->y, pMsg->z, pMsg->w );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glVertex4iv ( IN GLMSG_VERTEX4IV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->vertex.Vertex4iv)( pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glVertex4s ( IN GLMSG_VERTEX4S *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->vertex.Vertex4s)( pMsg->x, pMsg->y, pMsg->z, pMsg->w );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glVertex4sv ( IN GLMSG_VERTEX4SV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->vertex.Vertex4sv)( pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glClipPlane ( IN GLMSG_CLIPPLANE *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.ClipPlane)( pMsg->plane, pMsg->equation );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glColorMaterial ( IN GLMSG_COLORMATERIAL *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.ColorMaterial)( pMsg->face, pMsg->mode );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glCullFace ( IN GLMSG_CULLFACE *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.CullFace)( pMsg->mode );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glFogfv ( IN GLMSG_FOGFV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.Fogfv)( pMsg->pname, &pMsg->params[0] );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glFogiv ( IN GLMSG_FOGIV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.Fogiv)( pMsg->pname, &pMsg->params[0] );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glFrontFace ( IN GLMSG_FRONTFACE *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.FrontFace)( pMsg->mode );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glHint ( IN GLMSG_HINT *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.Hint)( pMsg->target, pMsg->mode );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glLightfv ( IN GLMSG_LIGHTFV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.Lightfv)( pMsg->light, pMsg->pname, &pMsg->params[0] );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glLightiv ( IN GLMSG_LIGHTIV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.Lightiv)( pMsg->light, pMsg->pname, &pMsg->params[0] );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glLightModelfv ( IN GLMSG_LIGHTMODELFV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.LightModelfv)( pMsg->pname, &pMsg->params[0] );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glLightModeliv ( IN GLMSG_LIGHTMODELIV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.LightModeliv)( pMsg->pname, &pMsg->params[0] );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glLineStipple ( IN GLMSG_LINESTIPPLE *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.LineStipple)( pMsg->factor, pMsg->pattern );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glLineWidth ( IN GLMSG_LINEWIDTH *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.LineWidth)( pMsg->width );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glMaterialfv ( IN GLMSG_MATERIALFV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.Materialfv)( pMsg->face, pMsg->pname, &pMsg->params[0] );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glMaterialiv ( IN GLMSG_MATERIALIV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.Materialiv)( pMsg->face, pMsg->pname, &pMsg->params[0] );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glPointSize ( IN GLMSG_POINTSIZE *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.PointSize)( pMsg->size );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glPolygonMode ( IN GLMSG_POLYGONMODE *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.PolygonMode)( pMsg->face, pMsg->mode );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glScissor ( IN GLMSG_SCISSOR *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.Scissor)( pMsg->x, pMsg->y, pMsg->width, pMsg->height );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glShadeModel ( IN GLMSG_SHADEMODEL *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.ShadeModel)( pMsg->mode );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glTexParameterfv ( IN GLMSG_TEXPARAMETERFV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.TexParameterfv)( pMsg->target, pMsg->pname, &pMsg->params[0] );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glTexParameteriv ( IN GLMSG_TEXPARAMETERIV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.TexParameteriv)( pMsg->target, pMsg->pname, &pMsg->params[0] );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glTexEnvfv ( IN GLMSG_TEXENVFV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.TexEnvfv)( pMsg->target, pMsg->pname, &pMsg->params[0] );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glTexEnviv ( IN GLMSG_TEXENVIV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.TexEnviv)( pMsg->target, pMsg->pname, &pMsg->params[0] );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glTexGendv ( IN GLMSG_TEXGENDV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.TexGendv)( pMsg->coord, pMsg->pname, &pMsg->params[0] );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glTexGenfv ( IN GLMSG_TEXGENFV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.TexGenfv)( pMsg->coord, pMsg->pname, &pMsg->params[0] );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glTexGeniv ( IN GLMSG_TEXGENIV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.TexGeniv)( pMsg->coord, pMsg->pname, &pMsg->params[0] );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glInitNames ( IN GLMSG_INITNAMES *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.InitNames)( );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glLoadName ( IN GLMSG_LOADNAME *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.LoadName)( pMsg->name );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glPassThrough ( IN GLMSG_PASSTHROUGH *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.PassThrough)( pMsg->token );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glPopName ( IN GLMSG_POPNAME *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.PopName)( );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glPushName ( IN GLMSG_PUSHNAME *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.PushName)( pMsg->name );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glDrawBuffer ( IN GLMSG_DRAWBUFFER *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.DrawBuffer)( pMsg->mode );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glClear ( IN GLMSG_CLEAR *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.Clear)( pMsg->mask );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glClearAccum ( IN GLMSG_CLEARACCUM *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.ClearAccum)( pMsg->red, pMsg->green, pMsg->blue, pMsg->alpha );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glClearIndex ( IN GLMSG_CLEARINDEX *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.ClearIndex)( pMsg->c );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glClearColor ( IN GLMSG_CLEARCOLOR *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.ClearColor)( pMsg->red, pMsg->green, pMsg->blue, pMsg->alpha );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glClearStencil ( IN GLMSG_CLEARSTENCIL *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.ClearStencil)( pMsg->s );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glClearDepth ( IN GLMSG_CLEARDEPTH *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.ClearDepth)( pMsg->depth );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glStencilMask ( IN GLMSG_STENCILMASK *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.StencilMask)( pMsg->mask );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glColorMask ( IN GLMSG_COLORMASK *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.ColorMask)( pMsg->red, pMsg->green, pMsg->blue, pMsg->alpha );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glDepthMask ( IN GLMSG_DEPTHMASK *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.DepthMask)( pMsg->flag );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glIndexMask ( IN GLMSG_INDEXMASK *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.IndexMask)( pMsg->mask );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glAccum ( IN GLMSG_ACCUM *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.Accum)( pMsg->op, pMsg->value );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glDisable ( IN GLMSG_DISABLE *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.Disable)( pMsg->cap );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glEnable ( IN GLMSG_ENABLE *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.Enable)( pMsg->cap );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glPopAttrib ( IN GLMSG_POPATTRIB *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.PopAttrib)( );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glPushAttrib ( IN GLMSG_PUSHATTRIB *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.PushAttrib)( pMsg->mask );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glMapGrid1d ( IN GLMSG_MAPGRID1D *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.MapGrid1d)( pMsg->un, pMsg->u1, pMsg->u2 );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glMapGrid1f ( IN GLMSG_MAPGRID1F *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.MapGrid1f)( pMsg->un, pMsg->u1, pMsg->u2 );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glMapGrid2d ( IN GLMSG_MAPGRID2D *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.MapGrid2d)( pMsg->un, pMsg->u1, pMsg->u2, pMsg->vn, pMsg->v1, pMsg->v2 );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glMapGrid2f ( IN GLMSG_MAPGRID2F *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.MapGrid2f)( pMsg->un, pMsg->u1, pMsg->u2, pMsg->vn, pMsg->v1, pMsg->v2 );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glEvalCoord1d ( IN GLMSG_EVALCOORD1D *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.EvalCoord1d)( pMsg->u );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glEvalCoord1dv ( IN GLMSG_EVALCOORD1DV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.EvalCoord1dv)( pMsg->u );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glEvalCoord1f ( IN GLMSG_EVALCOORD1F *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.EvalCoord1f)( pMsg->u );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glEvalCoord1fv ( IN GLMSG_EVALCOORD1FV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.EvalCoord1fv)( pMsg->u );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glEvalCoord2d ( IN GLMSG_EVALCOORD2D *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.EvalCoord2d)( pMsg->u, pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glEvalCoord2dv ( IN GLMSG_EVALCOORD2DV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.EvalCoord2dv)( pMsg->u );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glEvalCoord2f ( IN GLMSG_EVALCOORD2F *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.EvalCoord2f)( pMsg->u, pMsg->v );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glEvalCoord2fv ( IN GLMSG_EVALCOORD2FV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.EvalCoord2fv)( pMsg->u );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glEvalMesh1 ( IN GLMSG_EVALMESH1 *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.EvalMesh1)( pMsg->mode, pMsg->i1, pMsg->i2 );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glEvalPoint1 ( IN GLMSG_EVALPOINT1 *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.EvalPoint1)( pMsg->i );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glEvalMesh2 ( IN GLMSG_EVALMESH2 *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.EvalMesh2)( pMsg->mode, pMsg->i1, pMsg->i2, pMsg->j1, pMsg->j2 );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glEvalPoint2 ( IN GLMSG_EVALPOINT2 *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.EvalPoint2)( pMsg->i, pMsg->j );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glAlphaFunc ( IN GLMSG_ALPHAFUNC *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.AlphaFunc)( pMsg->func, pMsg->ref );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glBlendFunc ( IN GLMSG_BLENDFUNC *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.BlendFunc)( pMsg->sfactor, pMsg->dfactor );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glLogicOp ( IN GLMSG_LOGICOP *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.LogicOp)( pMsg->opcode );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glStencilFunc ( IN GLMSG_STENCILFUNC *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.StencilFunc)( pMsg->func, pMsg->ref, pMsg->mask );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glStencilOp ( IN GLMSG_STENCILOP *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.StencilOp)( pMsg->fail, pMsg->zfail, pMsg->zpass );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glDepthFunc ( IN GLMSG_DEPTHFUNC *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.DepthFunc)( pMsg->func );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glPixelZoom ( IN GLMSG_PIXELZOOM *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.PixelZoom)( pMsg->xfactor, pMsg->yfactor );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glPixelTransferf ( IN GLMSG_PIXELTRANSFERF *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.PixelTransferf)( pMsg->pname, pMsg->param );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glPixelTransferi ( IN GLMSG_PIXELTRANSFERI *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.PixelTransferi)( pMsg->pname, pMsg->param );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glPixelStoref ( IN GLMSG_PIXELSTOREF *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.PixelStoref)( pMsg->pname, pMsg->param );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glPixelStorei ( IN GLMSG_PIXELSTOREI *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.PixelStorei)( pMsg->pname, pMsg->param );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glPixelMapfv ( IN GLMSG_PIXELMAPFV *pMsg )
{

// VARIABLE_IN

    VOID *pData;
    BOOL Large = FALSE;
    VOID *NextOffset;
    __GLcontext *gc;

    NextOffset = (VOID *) ( ((BYTE *)pMsg) + pMsg->MsgSize );

    if ( pMsg->DataSize )
    {
        if ( pMsg->valuesOff )
        {
            Large = TRUE;

            if ( NULL == (pData = __wglTempAlloc(gc = __gl_context, pMsg->DataSize )) )
            {
                DBGERROR("__wglTempAlloc failed\n");
                return( NextOffset );
            }
            else
            {
                if ( FALSE == glsrvuCopyClientData(
                        pData,
                        (VOID *)pMsg->valuesOff,
                        pMsg->DataSize )
                   )
                {
                    __glSetError(GL_INVALID_VALUE);
                    DBGERROR("glsrvuCopyClientData failed\n");
                    __wglTempFree(gc, pData );
                    return( NextOffset );
                }
            }
        }
        else
        {
            pData = (VOID *)((BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)));
        }
    }
    else
    {
        pData = NULL;
    }

    (*GLTEB_SRVDISPATCHTABLE->dispatch.PixelMapfv)( pMsg->map, pMsg->mapsize, pData );

    if ( Large )
    {
        __wglTempFree(gc, pData );
    }

    return( NextOffset );
}

VOID *
sbs_glPixelMapuiv ( IN GLMSG_PIXELMAPUIV *pMsg )
{

// VARIABLE_IN

    VOID *pData;
    BOOL Large = FALSE;
    VOID *NextOffset;
    __GLcontext *gc;

    NextOffset = (VOID *) ( ((BYTE *)pMsg) + pMsg->MsgSize );

    if ( pMsg->DataSize )
    {
        if ( pMsg->valuesOff )
        {
            Large = TRUE;

            if ( NULL == (pData = __wglTempAlloc(gc = __gl_context, pMsg->DataSize )) )
            {
                DBGERROR("__wglTempAlloc failed\n");
                return( NextOffset );
            }
            else
            {
                if ( FALSE == glsrvuCopyClientData(
                        pData,
                        (VOID *)pMsg->valuesOff,
                        pMsg->DataSize )
                   )
                {
                    __glSetError(GL_INVALID_VALUE);
                    DBGERROR("glsrvuCopyClientData failed\n");
                    __wglTempFree(gc, pData );
                    return( NextOffset );
                }
            }
        }
        else
        {
            pData = (VOID *)((BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)));
        }
    }
    else
    {
        pData = NULL;
    }

    (*GLTEB_SRVDISPATCHTABLE->dispatch.PixelMapuiv)( pMsg->map, pMsg->mapsize, pData );

    if ( Large )
    {
        __wglTempFree(gc, pData );
    }

    return( NextOffset );
}

VOID *
sbs_glPixelMapusv ( IN GLMSG_PIXELMAPUSV *pMsg )
{

// VARIABLE_IN

    VOID *pData;
    BOOL Large = FALSE;
    VOID *NextOffset;
    __GLcontext *gc;

    NextOffset = (VOID *) ( ((BYTE *)pMsg) + pMsg->MsgSize );

    if ( pMsg->DataSize )
    {
        if ( pMsg->valuesOff )
        {
            Large = TRUE;

            if ( NULL == (pData = __wglTempAlloc(gc = __gl_context, pMsg->DataSize )) )
            {
                DBGERROR("__wglTempAlloc failed\n");
                return( NextOffset );
            }
            else
            {
                if ( FALSE == glsrvuCopyClientData(
                        pData,
                        (VOID *)pMsg->valuesOff,
                        pMsg->DataSize )
                   )
                {
                    __glSetError(GL_INVALID_VALUE);
                    DBGERROR("glsrvuCopyClientData failed\n");
                    __wglTempFree(gc, pData );
                    return( NextOffset );
                }
            }
        }
        else
        {
            pData = (VOID *)((BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)));
        }
    }
    else
    {
        pData = NULL;
    }

    (*GLTEB_SRVDISPATCHTABLE->dispatch.PixelMapusv)( pMsg->map, pMsg->mapsize, pData );

    if ( Large )
    {
        __wglTempFree(gc, pData );
    }

    return( NextOffset );
}

VOID *
sbs_glReadBuffer ( IN GLMSG_READBUFFER *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.ReadBuffer)( pMsg->mode );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glCopyPixels ( IN GLMSG_COPYPIXELS *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.CopyPixels)( pMsg->x, pMsg->y, pMsg->width, pMsg->height, pMsg->type );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glGetBooleanv ( IN GLMSG_GETBOOLEANV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.GetBooleanv)( pMsg->pname, &pMsg->params[0] );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glGetClipPlane ( IN GLMSG_GETCLIPPLANE *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.GetClipPlane)( pMsg->plane, pMsg->equation );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glGetDoublev ( IN GLMSG_GETDOUBLEV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.GetDoublev)( pMsg->pname, &pMsg->params[0] );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glGetError ( IN GLMSG_GETERROR *pMsg )
{
    GLTEB_SRVRETURNVALUE =
        (ULONG)(*GLTEB_SRVDISPATCHTABLE->dispatch.GetError)( );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glGetFloatv ( IN GLMSG_GETFLOATV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.GetFloatv)( pMsg->pname, &pMsg->params[0] );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glGetIntegerv ( IN GLMSG_GETINTEGERV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.GetIntegerv)( pMsg->pname, &pMsg->params[0] );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glGetLightfv ( IN GLMSG_GETLIGHTFV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.GetLightfv)( pMsg->light, pMsg->pname, &pMsg->params[0] );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glGetLightiv ( IN GLMSG_GETLIGHTIV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.GetLightiv)( pMsg->light, pMsg->pname, &pMsg->params[0] );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glGetMapdv ( IN GLMSG_GETMAPDV *pMsg )
{

// VARIABLE_OUT

    VOID *pData;
    BOOL Large = FALSE;
    VOID *NextOffset;
    __GLcontext *gc;

    NextOffset = (VOID *) ( ((BYTE *)pMsg) + pMsg->MsgSize );

    if ( pMsg->DataSize )
    {
        if ( pMsg->vOff )
        {
            Large = TRUE;

            if ( NULL == (pData = __wglTempAlloc(gc = __gl_context, pMsg->DataSize )) )
            {
                DBGERROR("__wglTempAlloc failed\n");
                return( NextOffset );
            }
        }
        else
        {
            pData = (VOID *)((BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)));
        }
    }
    else
    {
        pData = NULL;
    }

    (*GLTEB_SRVDISPATCHTABLE->dispatch.GetMapdv)( pMsg->target, pMsg->query, pData );

    if ( Large )
    {
        if ( FALSE == glsrvuSetClientData( (VOID *)pMsg->vOff, 
                pData,
                pMsg->DataSize)
           )
        {
            __glSetError(GL_INVALID_VALUE);
            DBGERROR("glsrvuSetClientData failed\n");
        }
        __wglTempFree(gc, pData );
    }

    return( NextOffset );
}

VOID *
sbs_glGetMapfv ( IN GLMSG_GETMAPFV *pMsg )
{

// VARIABLE_OUT

    VOID *pData;
    BOOL Large = FALSE;
    VOID *NextOffset;
    __GLcontext *gc;

    NextOffset = (VOID *) ( ((BYTE *)pMsg) + pMsg->MsgSize );

    if ( pMsg->DataSize )
    {
        if ( pMsg->vOff )
        {
            Large = TRUE;

            if ( NULL == (pData = __wglTempAlloc(gc = __gl_context, pMsg->DataSize )) )
            {
                DBGERROR("__wglTempAlloc failed\n");
                return( NextOffset );
            }
        }
        else
        {
            pData = (VOID *)((BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)));
        }
    }
    else
    {
        pData = NULL;
    }

    (*GLTEB_SRVDISPATCHTABLE->dispatch.GetMapfv)( pMsg->target, pMsg->query, pData );

    if ( Large )
    {
        if ( FALSE == glsrvuSetClientData( (VOID *)pMsg->vOff, 
                pData,
                pMsg->DataSize)
           )
        {
            __glSetError(GL_INVALID_VALUE);
            DBGERROR("glsrvuSetClientData failed\n");
        }
        __wglTempFree(gc, pData );
    }

    return( NextOffset );
}

VOID *
sbs_glGetMapiv ( IN GLMSG_GETMAPIV *pMsg )
{

// VARIABLE_OUT

    VOID *pData;
    BOOL Large = FALSE;
    VOID *NextOffset;
    __GLcontext *gc;

    NextOffset = (VOID *) ( ((BYTE *)pMsg) + pMsg->MsgSize );

    if ( pMsg->DataSize )
    {
        if ( pMsg->vOff )
        {
            Large = TRUE;

            if ( NULL == (pData = __wglTempAlloc(gc = __gl_context, pMsg->DataSize )) )
            {
                DBGERROR("__wglTempAlloc failed\n");
                return( NextOffset );
            }
        }
        else
        {
            pData = (VOID *)((BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)));
        }
    }
    else
    {
        pData = NULL;
    }

    (*GLTEB_SRVDISPATCHTABLE->dispatch.GetMapiv)( pMsg->target, pMsg->query, pData );

    if ( Large )
    {
        if ( FALSE == glsrvuSetClientData( (VOID *)pMsg->vOff, 
                pData,
                pMsg->DataSize)
           )
        {
            __glSetError(GL_INVALID_VALUE);
            DBGERROR("glsrvuSetClientData failed\n");
        }
        __wglTempFree(gc, pData );
    }

    return( NextOffset );
}

VOID *
sbs_glGetMaterialfv ( IN GLMSG_GETMATERIALFV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.GetMaterialfv)( pMsg->face, pMsg->pname, &pMsg->params[0] );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glGetMaterialiv ( IN GLMSG_GETMATERIALIV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.GetMaterialiv)( pMsg->face, pMsg->pname, &pMsg->params[0] );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glGetPixelMapfv ( IN GLMSG_GETPIXELMAPFV *pMsg )
{

// VARIABLE_OUT

    VOID *pData;
    BOOL Large = FALSE;
    VOID *NextOffset;
    __GLcontext *gc;

    NextOffset = (VOID *) ( ((BYTE *)pMsg) + pMsg->MsgSize );

    if ( pMsg->DataSize )
    {
        if ( pMsg->valuesOff )
        {
            Large = TRUE;

            if ( NULL == (pData = __wglTempAlloc(gc = __gl_context, pMsg->DataSize )) )
            {
                DBGERROR("__wglTempAlloc failed\n");
                return( NextOffset );
            }
        }
        else
        {
            pData = (VOID *)((BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)));
        }
    }
    else
    {
        pData = NULL;
    }

    (*GLTEB_SRVDISPATCHTABLE->dispatch.GetPixelMapfv)( pMsg->map, pData );

    if ( Large )
    {
        if ( FALSE == glsrvuSetClientData( (VOID *)pMsg->valuesOff, 
                pData,
                pMsg->DataSize)
           )
        {
            __glSetError(GL_INVALID_VALUE);
            DBGERROR("glsrvuSetClientData failed\n");
        }
        __wglTempFree(gc, pData );
    }

    return( NextOffset );
}

VOID *
sbs_glGetPixelMapuiv ( IN GLMSG_GETPIXELMAPUIV *pMsg )
{

// VARIABLE_OUT

    VOID *pData;
    BOOL Large = FALSE;
    VOID *NextOffset;
    __GLcontext *gc;

    NextOffset = (VOID *) ( ((BYTE *)pMsg) + pMsg->MsgSize );

    if ( pMsg->DataSize )
    {
        if ( pMsg->valuesOff )
        {
            Large = TRUE;

            if ( NULL == (pData = __wglTempAlloc(gc = __gl_context, pMsg->DataSize )) )
            {
                DBGERROR("__wglTempAlloc failed\n");
                return( NextOffset );
            }
        }
        else
        {
            pData = (VOID *)((BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)));
        }
    }
    else
    {
        pData = NULL;
    }

    (*GLTEB_SRVDISPATCHTABLE->dispatch.GetPixelMapuiv)( pMsg->map, pData );

    if ( Large )
    {
        if ( FALSE == glsrvuSetClientData( (VOID *)pMsg->valuesOff, 
                pData,
                pMsg->DataSize)
           )
        {
            __glSetError(GL_INVALID_VALUE);
            DBGERROR("glsrvuSetClientData failed\n");
        }
        __wglTempFree(gc, pData );
    }

    return( NextOffset );
}

VOID *
sbs_glGetPixelMapusv ( IN GLMSG_GETPIXELMAPUSV *pMsg )
{

// VARIABLE_OUT

    VOID *pData;
    BOOL Large = FALSE;
    VOID *NextOffset;
    __GLcontext *gc;

    NextOffset = (VOID *) ( ((BYTE *)pMsg) + pMsg->MsgSize );

    if ( pMsg->DataSize )
    {
        if ( pMsg->valuesOff )
        {
            Large = TRUE;

            if ( NULL == (pData = __wglTempAlloc(gc = __gl_context, pMsg->DataSize )) )
            {
                DBGERROR("__wglTempAlloc failed\n");
                return( NextOffset );
            }
        }
        else
        {
            pData = (VOID *)((BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)));
        }
    }
    else
    {
        pData = NULL;
    }

    (*GLTEB_SRVDISPATCHTABLE->dispatch.GetPixelMapusv)( pMsg->map, pData );

    if ( Large )
    {
        if ( FALSE == glsrvuSetClientData( (VOID *)pMsg->valuesOff, 
                pData,
                pMsg->DataSize)
           )
        {
            __glSetError(GL_INVALID_VALUE);
            DBGERROR("glsrvuSetClientData failed\n");
        }
        __wglTempFree(gc, pData );
    }

    return( NextOffset );
}

VOID *
sbs_glGetTexEnvfv ( IN GLMSG_GETTEXENVFV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.GetTexEnvfv)( pMsg->target, pMsg->pname, &pMsg->params[0] );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glGetTexEnviv ( IN GLMSG_GETTEXENVIV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.GetTexEnviv)( pMsg->target, pMsg->pname, &pMsg->params[0] );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glGetTexGendv ( IN GLMSG_GETTEXGENDV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.GetTexGendv)( pMsg->coord, pMsg->pname, &pMsg->params[0] );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glGetTexGenfv ( IN GLMSG_GETTEXGENFV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.GetTexGenfv)( pMsg->coord, pMsg->pname, &pMsg->params[0] );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glGetTexGeniv ( IN GLMSG_GETTEXGENIV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.GetTexGeniv)( pMsg->coord, pMsg->pname, &pMsg->params[0] );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glGetTexParameterfv ( IN GLMSG_GETTEXPARAMETERFV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.GetTexParameterfv)( pMsg->target, pMsg->pname, &pMsg->params[0] );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glGetTexParameteriv ( IN GLMSG_GETTEXPARAMETERIV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.GetTexParameteriv)( pMsg->target, pMsg->pname, &pMsg->params[0] );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glGetTexLevelParameterfv ( IN GLMSG_GETTEXLEVELPARAMETERFV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.GetTexLevelParameterfv)( pMsg->target, pMsg->level, pMsg->pname, &pMsg->params[0] );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glGetTexLevelParameteriv ( IN GLMSG_GETTEXLEVELPARAMETERIV *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.GetTexLevelParameteriv)( pMsg->target, pMsg->level, pMsg->pname, &pMsg->params[0] );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glIsEnabled ( IN GLMSG_ISENABLED *pMsg )
{
    GLTEB_SRVRETURNVALUE =
        (ULONG)(*GLTEB_SRVDISPATCHTABLE->dispatch.IsEnabled)( pMsg->cap );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glIsList ( IN GLMSG_ISLIST *pMsg )
{
    GLTEB_SRVRETURNVALUE =
        (ULONG)(*GLTEB_SRVDISPATCHTABLE->dispatch.IsList)( pMsg->list );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glDepthRange ( IN GLMSG_DEPTHRANGE *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.DepthRange)( pMsg->zNear, pMsg->zFar );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glFrustum ( IN GLMSG_FRUSTUM *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.Frustum)( pMsg->left, pMsg->right, pMsg->bottom, pMsg->top, pMsg->zNear, pMsg->zFar );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glLoadIdentity ( IN GLMSG_LOADIDENTITY *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.LoadIdentity)( );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glLoadMatrixf ( IN GLMSG_LOADMATRIXF *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.LoadMatrixf)( pMsg->m );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glLoadMatrixd ( IN GLMSG_LOADMATRIXD *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.LoadMatrixd)( pMsg->m );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glMatrixMode ( IN GLMSG_MATRIXMODE *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.MatrixMode)( pMsg->mode );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glMultMatrixf ( IN GLMSG_MULTMATRIXF *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.MultMatrixf)( pMsg->m );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glMultMatrixd ( IN GLMSG_MULTMATRIXD *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.MultMatrixd)( pMsg->m );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glOrtho ( IN GLMSG_ORTHO *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.Ortho)( pMsg->left, pMsg->right, pMsg->bottom, pMsg->top, pMsg->zNear, pMsg->zFar );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glPopMatrix ( IN GLMSG_POPMATRIX *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.PopMatrix)( );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glPushMatrix ( IN GLMSG_PUSHMATRIX *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.PushMatrix)( );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glRotated ( IN GLMSG_ROTATED *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.Rotated)( pMsg->angle, pMsg->x, pMsg->y, pMsg->z );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glRotatef ( IN GLMSG_ROTATEF *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.Rotatef)( pMsg->angle, pMsg->x, pMsg->y, pMsg->z );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glScaled ( IN GLMSG_SCALED *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.Scaled)( pMsg->x, pMsg->y, pMsg->z );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glScalef ( IN GLMSG_SCALEF *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.Scalef)( pMsg->x, pMsg->y, pMsg->z );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glTranslated ( IN GLMSG_TRANSLATED *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.Translated)( pMsg->x, pMsg->y, pMsg->z );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glTranslatef ( IN GLMSG_TRANSLATEF *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.Translatef)( pMsg->x, pMsg->y, pMsg->z );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

VOID *
sbs_glViewport ( IN GLMSG_VIEWPORT *pMsg )
{
    (*GLTEB_SRVDISPATCHTABLE->dispatch.Viewport)( pMsg->x, pMsg->y, pMsg->width, pMsg->height );

    return ( (BYTE *)pMsg + GLMSG_ALIGN(sizeof(*pMsg)) );
}

